<div id="dataspace-current-consumption">
  <table
    mat-table
    [dataSource]="dataSource"
    class="dataspace-current-table border-grey-600"
    aria-label="Single Data Space current consumptions table"
  >
    <ng-container matColumnDef="nodeName">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>Node</th>
      <td mat-cell *matCellDef="let currentConsumption">
        {{ currentConsumption.nodeName | titlecaseNodeName }}
      </td>
    </ng-container>

    <ng-container matColumnDef="categoryName">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>Category</th>
      <td mat-cell *matCellDef="let currentConsumption">
        {{ currentConsumption.categoryName | titlecaseNodeName }}
      </td>
    </ng-container>

    <ng-container matColumnDef="componentName">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>Component</th>
      <td mat-cell *matCellDef="let currentConsumption">
        {{
          (currentConsumption.componentName | titlecaseNodeName)
            ?.replace("FE", "Front-end")
            ?.replace("BE", "Back-end")
        }}
      </td>
    </ng-container>

    <ng-container matColumnDef="cpu">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>CPU</th>
      <td mat-cell *matCellDef="let currentConsumption">
        <span>
          {{
            (currentConsumption.cpuUsed
              | number: optimiseDecimalDigits(currentConsumption.cpuUsed)) +
              " / " +
              (currentConsumption.cpuAllocated
                | number
                  : optimiseDecimalDigits(currentConsumption.cpuAllocated)) +
              " cores"
          }}
          <b>
            {{
              " (" +
                (currentConsumption.cpuUsed / currentConsumption.cpuAllocated
                  | percent: "1.0-2") +
                ")"
            }}
          </b>
        </span>
      </td>
    </ng-container>

    <ng-container matColumnDef="memory">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>Memory</th>
      <td mat-cell *matCellDef="let currentConsumption">
        <span>
          {{
            (currentConsumption.memoryUsed
              | number: optimiseDecimalDigits(currentConsumption.memoryUsed)) +
              " / " +
              (currentConsumption.memoryAllocated
                | number
                  : optimiseDecimalDigits(currentConsumption.memoryAllocated)) +
              " GB"
          }}
          <b>
            {{
              " (" +
                (currentConsumption.memoryUsed /
                  currentConsumption.memoryAllocated | percent: "1.0-1") +
                ")"
            }}
          </b>
        </span>
      </td>
    </ng-container>

    <ng-container matColumnDef="storage">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>Storage</th>
      <td mat-cell *matCellDef="let currentConsumption">
        <span>
          {{
            (currentConsumption.storageUsed
              | number: optimiseDecimalDigits(currentConsumption.storageUsed)) +
              " / " +
              (currentConsumption.storageAllocated
                | number
                  : optimiseDecimalDigits(
                      currentConsumption.storageAllocated
                    )) +
              " GB"
          }}
          <b>
            {{
              " (" +
                (currentConsumption.storageUsed /
                  currentConsumption.storageAllocated | percent: "1.0-1") +
                ")"
            }}
          </b>
        </span>
      </td>
    </ng-container>

    <ng-container matColumnDef="details">
      <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>
        {{ (currentDomain | lowercase) !== "component" ? "Details" : " " }}
      </th>
      <td mat-cell *matCellDef="let currentConsumption">
        @if (currentDomain.toLowerCase() !== "component") {
          <button
            class="justify-content-end p-0"
            mat-button
            color="primary"
            (click)="viewDetails(currentConsumption)"
          >
            <mat-icon class="arrow-forward-icon">arrow_forward</mat-icon>
          </button>
        }
      </td>
    </ng-container>

    @for (col of secondHeaderCols; track col) {
      @if (col === "_cpu" || col === "_memory" || col === "_storage") {
        <ng-container matColumnDef="{{ col }}">
          <th class="bg-grey-300" mat-header-cell *matHeaderCellDef>
            (used/allocated)
          </th>
        </ng-container>
      } @else {
        <ng-container matColumnDef="{{ col }}">
          <th class="bg-grey-300" mat-header-cell *matHeaderCellDef></th>
        </ng-container>
      }
    }

    <tr
      class="first-header-row"
      mat-header-row
      *matHeaderRowDef="tableColumns"
    ></tr>

    <tr
      class="second-header-row"
      mat-header-row
      *matHeaderRowDef="secondHeaderCols"
    ></tr>

    <tr mat-row *matRowDef="let row; columns: tableColumns"></tr>
  </table>

  <mat-paginator
    [length]="paginator && paginator.totalElements"
    [pageSize]="paginator && paginator.size"
    [pageIndex]="paginator && paginator.number"
    [pageSizeOptions]="[5, 10, 25, 50, 100]"
    [hidePageSize]="false"
    (page)="onPaginatorChange($event)"
    color="primary"
    aria-label="Select page"
  >
  </mat-paginator>
</div>
